﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;

namespace DragDataGridView
{
    public class DataSerializer
    {
        /// <summary>
        /// Binary Serialize
        /// </summary>
        public static string SerializeObject(object obj)
        {
            StringBuilder sb = new StringBuilder();

            if (obj == null)
                return null;
            MemoryStream ms = new MemoryStream();
            BinaryFormatter formatter = new BinaryFormatter();
            formatter.Serialize(ms, obj);
            ms.Position = 0;
            byte[] bytes = new byte[ms.Length];
            ms.Read(bytes, 0, bytes.Length);
            ms.Close();
            string str = Convert.ToBase64String(bytes);
            return str;
        }

        /// <summary>
        /// Binary Deserialize
        /// </summary>
        public static object DeserializeObject(string str)
        {
            byte[] bytes = Convert.FromBase64String(str);
            object obj = null;
            if (bytes == null)
                return obj;
            MemoryStream ms = new MemoryStream(bytes);
            ms.Position = 0;
            BinaryFormatter formatter = new BinaryFormatter();
            obj = formatter.Deserialize(ms);
            ms.Close();
            return obj;
        }
    }
}
